#pragma once

#include "core/script.hpp"
#include "geometry/paddle.hpp"

#include "constants.hpp"


struct wall_script : frog::script
{
    frog::geo::paddle paddle;

    wall_script(int element, int level)
        : paddle(create_paddle(element, level)) {}

    void init(frog::game_object& object, frog::engine&) override
    {
        object.model().rot.y() = paddle.pos.theta;
        object.model().pos.y() = paddle.pos.y;
    }

    static frog::geo::paddle create_paddle(int element, int level)
    {
        auto result         = frog::geo::paddle{};
        result.angular_size = Wall::AngularSize * frog::geo::ToRad;
        result.height       = Wall::Height;
        result.thickness    = Wall::Thickness;
        result.pos.r        = Wall::Radius;
        result.pos.theta    = element * result.angular_size;
        result.pos.y        = level * Wall::Height;

        return result;
    }
};
